<?php
/*
 *  $Id: ApiAbstract.php 412 2011-11-19 14:00:43Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_ApiAbstract
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Captcha
 * @version    $Revision: 412 $
 */
abstract class Amun_ApiAbstract extends Amun_Oauth
{
	protected $sql;
	protected $registry;
	protected $validate;
	protected $get;
	protected $post;

	protected $session;
	protected $user;

	public function __construct(PSX_Config $config, PSX_Template $template, $basePath, array $uriFragments)
	{
		parent::__construct($config, $template, $basePath, $uriFragments);


		$base = Amun_Base_Default::initInstance($config);

		$this->sql      = $base->getSql();
		$this->registry = $base->getRegistry();
		$this->validate = $base->getValidate();
		$this->get      = $base->getGet();
		$this->post     = $base->getPost();


		// if the authorization header is set follow the oauth
		// authentication process else assign the user from the session
		$authorization = PSX_Config::getRequestHeader('authorization');

		if($authorization !== false)
		{
			$this->doAuthentication();
		}
		else
		{
			$this->session = new PSX_Session('amun_' . md5($this->config['psx_url']), $this->validate);

			$this->user = new Amun_User(Amun_User::getId($this->session, $this->registry), $this->registry);
		}
	}

	public function onAuthenticated()
	{
		session_id($this->requestToken);

		$this->session = new PSX_Session('amun_api_' . md5($this->config['psx_url']), $this->validate);

		$this->user = new Amun_User($this->claimedUserId, $this->registry);
		$this->user->requestId = $this->requestId;
	}
}

