<?php
/*
 *  $Id: ApplicationAbstract.php 401 2011-11-13 23:42:41Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_ApplicationAbstract
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Captcha
 * @version    $Revision: 401 $
 */
abstract class Amun_ApplicationAbstract extends PSX_ModuleAbstract
{
	protected $application;

	protected $sql;
	protected $registry;
	protected $validate;
	protected $get;
	protected $post;

	protected $session;
	protected $user;
	protected $page;
	protected $nav;
	protected $path;
	protected $gadget;

	protected $htmlJs;
	protected $htmlCss;
	protected $htmlContent;

	public function __construct(PSX_Config $config, PSX_Template $template, $basePath, array $uriFragments, Amun_Base_Application $application)
	{
		parent::__construct($config, $template, $basePath, $uriFragments);

		$this->application = $application;

		$this->sql         = $application->getSql();
		$this->registry    = $application->getRegistry();
		$this->validate    = $application->getValidate();
		$this->get         = $application->getGet();
		$this->post        = $application->getPost();

		$this->session     = $application->getSession();
		$this->user        = $application->getUser();
		$this->page        = $application->getPage();
		$this->nav         = $application->getNav();
		$this->path        = $application->getPath();
		$this->gadget      = $application->getGadget();

		$this->htmlJs      = $application->getHtmlJs();
		$this->htmlCss     = $application->getHtmlCss();
		$this->htmlContent = $application->getHtmlContent();
	}
}

