<?php
/*
 *  $Id: Application.php 402 2011-11-14 23:08:31Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_Base_Application
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Base
 * @version    $Revision: 402 $
 */
class Amun_Base_Application extends Amun_Base_Default
{
	protected $session;
	protected $user;
	protected $page;
	protected $nav;
	protected $path;
	protected $gadget;
	protected $htmlJs;
	protected $htmlCss;
	protected $htmlContent;

	public function __construct(PSX_Config $config, $sessionName = 'amun')
	{
		parent::__construct($config);


		// session
		$this->session = new PSX_Session('amun_' . md5($this->config['psx_url']), $this->validate);

		$this->offsetSet('PSX_Session', $this->user);


		// user
		$id = Amun_User::getId($this->session, $this->registry);

		$this->user = new Amun_User($id, $this->registry);

		$this->offsetSet('Amun_User', $this->user);


		// page
		$this->page = new Amun_Page($this->registry, $this->user);

		$this->offsetSet('Amun_Page', $this->page);


		// nav
		$this->nav = new Amun_Nav($this->registry, $this->user, $this->page);

		$this->offsetSet('Amun_Nav', $this->nav);


		// path
		$this->path = new Amun_Path($this->registry, $this->page);

		$this->offsetSet('Amun_Path', $this->path);


		// gadget
		$this->gadget = new Amun_Gadget($this->registry, $this);

		$this->offsetSet('Amun_Gadget', $this->gadget);


		// html js
		$this->htmlJs = new Amun_Html_Js($this->config);

		$this->offsetSet('Amun_Html_Js', $this->htmlJs);


		// html css
		$this->htmlCss = new Amun_Html_Css($this->config);

		$this->offsetSet('Amun_Html_Css', $this->htmlCss);


		// html content
		$this->htmlContent = new Amun_Html_Content();

		$this->offsetSet('Amun_Html_Content', $this->htmlContent);
	}

	public function getSession()
	{
		return $this->session;
	}

	public function getUser()
	{
		return $this->user;
	}

	public function getPage()
	{
		return $this->page;
	}

	public function getNav()
	{
		return $this->nav;
	}

	public function getPath()
	{
		return $this->path;
	}

	public function getGadget()
	{
		return $this->gadget;
	}

	public function getHtmlJs()
	{
		return $this->htmlJs;
	}

	public function getHtmlCss()
	{
		return $this->htmlCss;
	}

	public function getHtmlContent()
	{
		return $this->htmlContent;
	}

	public static function initInstance(PSX_Config $config, $sessionName = 'amun')
	{
		return self::$_instance = new self($config, $sessionName);
	}
}
