<?php
/*
 *  $Id: HtmlAbstract.php 430 2011-12-03 18:04:42Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_Ext_HtmlAbstract
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Ext
 * @version    $Revision: 430 $
 */
abstract class Amun_Ext_HtmlAbstract
{
	private $config;
	private $services = array();

	public function __construct(PSX_Config $config)
	{
		$this->config = $config;
	}

	public function add($service)
	{
		if(!in_array($service, $this->services))
		{
			$this->services[] = $service;
		}
	}

	public function clear()
	{
		$this->services = array();
	}

	public function getUrl()
	{
		return $this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'ext?mode=' . get_class($this) . '&services=' . implode('|', $this->services);
	}

	public function __toString()
	{
		if(count($this->services) > 0)
		{
			return sprintf($this->getTag(), $this->getUrl());
		}
		else
		{
			return '';
		}
	}

	abstract public function getTag();
}
