<?php
/*
 *  $Id: HtmlPurifier.php 233 2011-05-01 00:36:01Z k42b3.x $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_Filter_HtmlPurifier
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Filter
 * @version    $Revision: 233 $
 */
class Amun_Filter_HtmlPurifier extends PSX_FilterAbstract
{
	private $purifier;
	private $purifierConfig;
	private $config;

	public function __construct(PSX_Config $config, array $options = array())
	{
		$this->config = $config;


		if(!defined('HTMLPURIFIER_PREFIX'))
		{
			define('HTMLPURIFIER_PREFIX', PSX_PATH_LIBRARY);
		}


		$this->purifierConfig = HTMLPurifier_Config::createDefault();

		foreach($options as $k => $v)
		{
			$this->purifierConfig->set($k, $v);
		}

		$this->purifierConfig->set('Core.Encoding', 'UTF-8');
		$this->purifierConfig->set('HTML.Doctype', 'XHTML 1.0 Strict');
		//$this->purifierConfig->set('URI.Base', $this->config['psx_url']);
		//$this->purifierConfig->set('URI.MakeAbsolute', true);
		//$this->purifierConfig->set('URI.DisableExternalResources', true);
		$this->purifierConfig->set('Cache.SerializerPath', PSX_PATH_CACHE);

		$this->purifier = new HTMLPurifier($this->purifierConfig);
	}

	public function apply($value)
	{
		return $this->purifier->purify($value);
	}

	public function getErrorMsg()
	{
		return '%s should contain only (' . $this->purifierConfig->get('HTML.Allowed') . ')';
	}
}

