<?php
/*
 *  $Id: Gadget.php 403 2011-11-15 22:07:13Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_Gadget
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Gadget
 * @version    $Revision: 403 $
 */
class Amun_Gadget extends ArrayObject
{
	private $config;
	private $sql;
	private $registry;
	private $application;

	private $gadgets = array();

	public function __construct(Amun_Registry $registry, Amun_Base_Application $application)
	{
		parent::__construct($this->gadgets);

		$this->config      = $registry->getConfig();
		$this->sql         = $registry->getSql();
		$this->registry    = $registry;
		$this->application = $application;
	}

	public function load($pageId)
	{
		$sql = <<<SQL
SELECT

	`pageGadget`.`gadgetId` AS `id`,
	`gadget`.`title`,
	`gadget`.`path`,
	`gadget`.`cache`,
	`gadget`.`expire`

	FROM {$this->registry['table.content_page_gadget']} `pageGadget`

		INNER JOIN {$this->registry['table.content_gadget']} `gadget`

		ON `pageGadget`.`gadgetId` = `gadget`.`id`

			WHERE `pageGadget`.`pageId` = {$pageId}

			ORDER BY `pageGadget`.`sort` ASC
SQL;

		$result = $this->sql->getAll($sql, array(), PSX_Sql::FETCH_OBJECT, 'Amun_Gadget_Item', array($this->registry, $this->application));

		foreach($result as $gadget)
		{
			// execute gadget
			try
			{
				$gadget->parseContent();
			}
			catch(Exception $e)
			{
				$gadget->setBody($e->getMessage() . "\n\n" . $e->getTraceAsString());
			}

			$this->append($gadget);
		}
	}
}

