<?php
/*
 *  $Id: Stomp.php 401 2011-11-13 23:42:41Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_Notify_Stomp
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Notify
 * @version    $Revision: 401 $
 */
class Amun_Notify_Stomp extends Amun_NotifyAbstract
{
	public function notify($type, PSX_Data_RecordInterface $record)
	{
		try
		{
			$headers = array(

				'amun-table' => $this->table->getName(),
				'amun-type'  => $type,

			);
			$message = PSX_Json::encode($record->getFields());

			$con = new Stomp('tcp://' . $this->config['amun_stomp_host'] . ':' . $this->config['amun_stomp_port']);
			$con->sync = false;
			$con->connect($this->config['amun_stomp_user'], $this->config['amun_stomp_pw']);
			$con->send('/queue/amun', $message, $headers);
			$con->disconnect();
		}
		catch(StompException $e)
		{
		}
		catch(Exception $e)
		{
		}
	}
}

