<?php
/*
 *  $Id: NotifyAbstract.php 401 2011-11-13 23:42:41Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_NotifyAbstract
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Notify
 * @version    $Revision: 401 $
 */
abstract class Amun_NotifyAbstract
{
	protected $table;
	protected $config;
	protected $sql;
	protected $registry;
	protected $user;

	public function __construct(Amun_Sql_TableInterface $table, Amun_User $user)
	{
		$this->table    = $table;
		$this->config   = $table->getRegistry()->getConfig();
		$this->sql      = $table->getSql();
		$this->registry = $table->getRegistry();
		$this->user     = $user;
	}

	abstract public function notify($type, PSX_Data_RecordInterface $record);
}

