<?php
/*
 *  $Id: Form.php 405 2011-11-16 21:42:16Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_System_Approval_Form
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_System_Approval
 * @version    $Revision: 405 $
 */
class Amun_System_Approval_Form extends Amun_Data_FormAbstract
{
	public function create()
	{
		$form = new Amun_Form('POST', $this->url);


		$panel = new Amun_Form_Element_Panel('approval', 'Approval');


		$table = new Amun_Form_Element_Select('table', 'Table');
		$table->setOptions($this->getTable());

		$panel->add($table);


		$field = new Amun_Form_Element_Input('field', 'Field');
		$field->setType('text');

		$panel->add($field);


		$value = new Amun_Form_Element_Input('value', 'Value');
		$value->setType('text');

		$panel->add($value);


		if($this->user->isAnonymous())
		{
			$captcha = new Amun_Form_Element_Captcha('captcha', 'Captcha');
			$captcha->setSrc($this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'api/system/captcha');

			$panel->add($captcha);
		}


		$form->setContainer($panel);


		return $form;
	}

	public function update($id)
	{
		$record = Amun_Sql_Table_Registry::get('System_Approval')->getRecord($id);


		$form = new Amun_Form('PUT', $this->url);


		$panel = new Amun_Form_Element_Panel('approval', 'Approval');


		$id = new Amun_Form_Element_Input('id', 'ID', $record->id);
		$id->setType('hidden');

		$panel->add($id);


		$table = new Amun_Form_Element_Select('table', 'Table', $record->table);
		$table->setOptions($this->getTable());

		$panel->add($table);


		$field = new Amun_Form_Element_Input('field', 'Field', $record->field);
		$field->setType('text');

		$panel->add($field);


		$value = new Amun_Form_Element_Input('value', 'Value', $record->value);
		$value->setType('text');

		$panel->add($value);


		if($this->user->isAnonymous())
		{
			$captcha = new Amun_Form_Element_Captcha('captcha', 'Captcha');
			$captcha->setSrc($this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'api/system/captcha');

			$panel->add($captcha);
		}


		$form->setContainer($panel);


		return $form;
	}

	public function delete($id)
	{
		$record = Amun_Sql_Table_Registry::get('System_Approval')->getRecord($id);


		$form = new Amun_Form('DELETE', $this->url);


		$panel = new Amun_Form_Element_Panel('approval', 'Approval');


		$id = new Amun_Form_Element_Input('id', 'ID', $record->id);
		$id->setType('hidden');

		$panel->add($id);


		$table = new Amun_Form_Element_Select('table', 'Table', $record->table);
		$table->setOptions($this->getTable());
		$table->setDisabled(true);

		$panel->add($table);


		$field = new Amun_Form_Element_Input('field', 'Field', $record->field);
		$field->setType('text');
		$field->setDisabled(true);

		$panel->add($field);


		$value = new Amun_Form_Element_Input('value', 'Value', $record->value);
		$value->setType('text');
		$value->setDisabled(true);

		$panel->add($value);


		if($this->user->isAnonymous())
		{
			$captcha = new Amun_Form_Element_Captcha('captcha', 'Captcha');
			$captcha->setSrc($this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'api/system/captcha');

			$panel->add($captcha);
		}


		$form->setContainer($panel);


		return $form;
	}

	private function getTable()
	{
		$result = $this->sql->getAll('SHOW TABLES');
		$tables = array();

		foreach($result as $row)
		{
			$name = current($row);

			array_push($tables, array(

				'label' => $name,
				'value' => $name,

			));
		}

		return $tables;
	}
}

