<?php
/*
 *  $Id: Class.php 224 2011-04-25 11:33:17Z k42b3.x $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_System_Notify_Filter_Class
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_System_Notify
 * @version    $Revision: 224 $
 */
class Amun_System_Notify_Filter_Class extends PSX_FilterAbstract
{
	private $errorMsg;

	public function apply($value)
	{
		try
		{
			$class = new ReflectionClass($value);

			if(!$class->isSubclassOf('Amun_NotifyAbstract'))
			{
				throw new Amun_Exception('Class is not a sub class of Amun_NotifyAbstract');
			}

			return $class->getName();
		}
		catch(Exception $e)
		{
			$this->errorMsg = $e->getMessage();

			return false;
		}
	}

	public function getErrorMsg()
	{
		return $this->errorMsg;
	}
}

