<?php
/*
 *  $Id: File.php 264 2011-04-03 12:09:45Z k42b3.x $
 *
 * psx
 * A object oriented and modular based PHP framework for developing
 * dynamic web applications. For the current version and informations
 * visit <http://phpsx.org>
 *
 * Copyright (c) 2011 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of psx. psx is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * psx is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with psx. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * PSX_Cache_Handler_File
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://phpsx.org
 * @category   PSX
 * @package    PSX_Cache
 * @version    $Revision: 264 $
 */
class PSX_Cache_Handler_File implements PSX_Cache_HandlerInterface
{
	public function load($key, $expire)
	{
		$file = PSX_PATH_CACHE . '/' . $key . '.cache';

		if(is_file($file))
		{
			$content = file_get_contents($file);
			$now     = time();
			$date    = filemtime($file);

			if($content !== false)
			{
				if(($now - $date) > $expire)
				{
					return false;
				}
				else
				{
					return $content;
				}
			}
			else
			{
				return false;
			}
		}
		else
		{
			return false;
		}
	}

	public function write($key, $content)
	{
		$file = new PSX_File(PSX_PATH_CACHE . '/' . $key . '.cache', 'w');

		$file->write($content);

		$file->close();
	}
}

