<?php
/*
 *  $Id: Message.php 365 2011-11-13 23:54:19Z k42b3.x@googlemail.com $
 *
 * psx
 * A object oriented and modular based PHP framework for developing
 * dynamic web applications. For the current version and informations
 * visit <http://phpsx.org>
 *
 * Copyright (c) 2011 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of psx. psx is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * psx is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with psx. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * PSX_Data_Message
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://phpsx.org
 * @category   PSX
 * @package    PSX_Data
 * @version    $Revision: 365 $
 */
class PSX_Data_Message extends PSX_Data_RecordAbstract
{
	public $text;
	public $success;

	public function __construct($text = null, $success = null)
	{
		$this->setText($text);
		$this->setSuccess($success);
	}

	public function getName()
	{
		return 'message';
	}

	public function getFields()
	{
		return array(

			'text'    => $this->text,
			'success' => $this->success,

		);
	}

	public function setText($text)
	{
		$this->text = $text;
	}

	public function setSuccess($success)
	{
		$this->success = (boolean) $success;
	}
}
