<?php
/*
 *  $Id: Email.php 354 2011-10-29 15:25:33Z k42b3.x@googlemail.com $
 *
 * psx
 * A object oriented and modular based PHP framework for developing
 * dynamic web applications. For the current version and informations
 * visit <http://phpsx.org>
 *
 * Copyright (c) 2011 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of psx. psx is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * psx is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with psx. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * PSX_Filter_Email
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://phpsx.org
 * @category   PSX
 * @package    PSX_Filter
 * @version    $Revision: 354 $
 */
class PSX_Filter_Email extends PSX_FilterAbstract
{
	/**
	 * apply
	 *
	 * Returns true if $value is a valid email address else false You can
	 * use this method as filter
	 *
	 * @param mixed $value
	 * @return boolean
	 */
	public function apply($value)
	{
		return filter_var((string) $value, FILTER_VALIDATE_EMAIL) === false ? false : true;
	}

	public function getErrorMsg()
	{
		return '%s must be a valid email format (user@domain.tld)';
	}
}
