<?php
/*
 *  $Id: Mysql.php 245 2011-03-24 01:07:52Z k42b3.x $
 *
 * psx
 * A object oriented and modular based PHP framework for developing
 * dynamic web applications. For the current version and informations
 * visit <http://phpsx.org>
 *
 * Copyright (c) 2011 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of psx. psx is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * psx is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with psx. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * PSX_Sql_Driver_Mysql
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://phpsx.org
 * @category   PSX
 * @package    PSX_Sql
 * @version    $Revision: 245 $
 */
class PSX_Sql_Driver_Mysql implements PSX_Sql_DriverInterface
{
	private $handle;
	private $stmt;

	public function connect($host, $user, $pw, $db)
	{
		$this->handle = mysql_connect($host, $user, $pw);

		if(!$this->handle || !mysql_select_db($db))
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	public function exec($sql)
	{
		if(mysql_query($sql, $this->handle) === false)
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	public function lastInsertId()
	{
		return mysql_insert_id($this->handle);
	}

	public function close()
	{
		mysql_close($this->handle);
	}

	public function quote($value)
	{
		return '\'' . mysql_real_escape_string(strval($value)) . '\'';
	}

	public function error()
	{
		$error = mysql_error();

		if(empty($error))
		{
			return false;
		}
		else
		{
			return $error;
		}
	}

	public function prepare($sql)
	{
		return new PSX_Sql_Driver_Mysql_Stmt($this->handle, $sql);
	}

	public function beginTransaction()
	{
		throw new PSX_Sql_Exception('mysql driver doesnt support transactions');
	}

	public function commit()
	{
		throw new PSX_Sql_Exception('mysql driver doesnt support commit');
	}

	public function rollback()
	{
		throw new PSX_Sql_Exception('mysql driver doesnt support rollback');
	}
}
