<?php
/*
 *  $Id: SelectInterface.php 368 2011-11-15 23:44:01Z k42b3.x@googlemail.com $
 *
 * psx
 * A object oriented and modular based PHP framework for developing
 * dynamic web applications. For the current version and informations
 * visit <http://phpsx.org>
 *
 * Copyright (c) 2011 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of psx. psx is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * psx is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with psx. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * PSX_Sql_Table_SelectInterface
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://phpsx.org
 * @category   PSX
 * @package    PSX_Sql
 * @version    $Revision: 368 $
 */
interface PSX_Sql_Table_SelectInterface
{
	public function join($type, $table, $cardinality = 'n:1', $foreignKey = null);
	public function where($column, $operator, $value, $conjunction = 'AND');
	public function groupBy($column);
	public function orderBy($column, $sort = 0x1);
	public function limit($start, $count = null);

	public function getResultSet($startIndex = 0, $count = 32, $sortBy = null, $sortOrder = null, $filterBy = null, $filterOp = null, $filterValue = null, $updatedSince = null, $mode = 0, $class = null, array $args = array());
	public function getAll($mode = 0, $class = null, array $args = array());
	public function getRow($mode = 0, $class = null, array $args = array());
	public function getCol();
	public function getField();
	public function getTotalResults();

	public function getTable();
	public function getSql();
	public function getCondition();
	public function setPrefix($prefix);
	public function setColumns(array $columns);
	public function getSupportedFields();
	public function getSelfColumns();
	public function getAllColumns();
	public function getSelectedColumns();
	public function getAllSelectedColumns();
	public function buildJoins();
}

