<?php
/*
 *  $Id: serve.php 254 2011-05-18 18:18:20Z k42b3.x $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * serve
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   module
 * @package    api
 * @subpackage content_media
 * @version    $Revision: 254 $
 */
class serve extends Amun_ApiAbstract
{
	public function onGet()
	{
		if($this->user->hasRight('content_media_view'))
		{
			try
			{
				$id = $this->get->id('integer');

				if($id <= 0)
				{
					throw new PSX_Data_Exception('Id not set');
				}


				$servlet = new Amun_Content_Media_Servlet($this->config, $this->sql, $this->vars);

				$params = $this->getRequestParams();

				$fields = !empty($params['fields']) ? $params['fields'] : array('id', 'authorName', 'title', 'path', 'type', 'size', 'mimeType', 'date');

				$servlet->setFields($fields);

				$servlet->addSelectCondition('id', '=', $id);

				$resultset = $servlet->getAll($params['startIndex'], $params['count'], $params['sortBy'], $params['sortOrder'], $params['filterBy'], $params['filterOp'], $params['filterValue'], $params['updatedSince']);


				if($resultset->hasResults())
				{
					$entry = $resultset->current();

					header('Content-type: ' . $entry['mimeType']);

					switch($entry['mimeType'])
					{
						case 'application/octet-stream':

							header('Content-disposition: attachment; filename="' . $entry['title'] . '"');

							break;
					}

					echo file_get_contents($this->vars['core.media_path'] . '/' . $entry['authorName'] . '/' . $entry['path']);
				}
				else
				{
					throw new PSX_Data_Exception('Invalid id');
				}
			}
			catch(Exception $e)
			{
				$msg = new PSX_Data_Message($e->getMessage(), false);

				$this->setResponse($msg);
			}
		}
		else
		{
			$msg = new PSX_Data_Message('Access not allowed', false);

			$this->setResponse($msg, $this->user->isAnonymous() ? 401 : 403);
		}
	}
}

