<?php
/*
 *  $Id: upload.php 231 2011-04-29 21:01:23Z k42b3.x $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * upload
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   module
 * @package    api
 * @subpackage content_media
 * @version    $Revision: 231 $
 */
class upload extends Amun_ApiAbstract
{
	public function onGet()
	{
		throw new PSX_Data_Exception('Invalid request method');
	}

	public function onPost()
	{
		if($this->user->hasRight('content_media_upload'))
		{
			try
			{
				$file = current($_FILES);

				$handler = new Amun_Content_Media_Handler($this->config, $this->sql, $this->vars, $this->user);

				$handler->upload($file);


				$msg = new PSX_Data_Message('You have successful upload a media', true);

				$this->setResponse($msg);
			}
			catch(Exception $e)
			{
				$msg = new PSX_Data_Message($e->getMessage(), false);

				$this->setResponse($msg);
			}
		}
		else
		{
			$msg = new PSX_Data_Message('Access not allowed', false);

			$this->setResponse($msg, $this->user->isAnonymous() ? 401 : 403);
		}
	}
}


