<?php
/*
 *  $Id: view.php 431 2011-12-03 18:11:04Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * view
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   module
 * @package    plugin
 * @subpackage news
 * @version    $Revision: 431 $
 */
class view extends Amun_ApplicationAbstract
{
	private $newsId;

	public function onLoad()
	{
		if($this->user->hasRight('service_news_view'))
		{
			// load news
			$recordNews = $this->getNews();

			$this->template->assign('recordNews', $recordNews);


			// load comments
			$resultComments = $this->getComments();

			$this->template->assign('resultComments', $resultComments);


			// add path
			$this->path->add($recordNews->title, $this->page->url . '/view?id=' . $this->newsId);


			// options
			$options = new Amun_Option(__CLASS__, $this->registry, $this->user, $this->page);
			$options->add('service_news_edit', 'Edit', $this->page->url . '/edit?id=' . $this->newsId);
			$options->load(array($this->page, $recordNews));

			$this->template->assign('options', $options);


			// form url
			$newsId = $this->get->id('integer');
			$pageId = $this->page->id;

			$url = $this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'api/service/comment/form?format=json&method=create&pageId=' . $pageId . '&refId=' . $newsId;

			$this->template->assign('url', $url);


			// template
			$this->htmlCss->add('news');
			$this->htmlCss->add('comment');
			$this->htmlJs->add('amun');
			$this->htmlJs->add('comment');

			$this->template->set('application/' . $this->page->application . '/' . __CLASS__ . '.tpl');
		}
		else
		{
			throw new Amun_Exception('Access not allowed');
		}
	}

	private function getNews()
	{
		$this->newsId = $this->get->id('integer');

		$result = Amun_Sql_Table_Registry::get('Service_News')
			->select(array('id', 'title', 'text', 'date'))
			->join(PSX_Sql_Join::INNER, Amun_Sql_Table_Registry::get('Content_Page')
				->select(array('path'), 'page')
			)
			->join(PSX_Sql_Join::INNER, Amun_Sql_Table_Registry::get('User_Account')
				->select(array('name', 'profileUrl', 'thumbnailUrl'), 'author')
			)
			->where('id', '=', $this->newsId)
			->getRow(PSX_Sql::FETCH_OBJECT);

		return $result;
	}

	private function getComments()
	{
		$table = Amun_Sql_Table_Registry::get('Service_Comment')
			->select(array('id', 'text', 'date'))
			->join(PSX_Sql_Join::INNER, Amun_Sql_Table_Registry::get('User_Account')
				->select(array('name', 'profileUrl', 'thumbnailUrl'), 'author')
			)
			->where('pageId', '=', $this->page->id)
			->where('refId', '=', $this->newsId);


		$url = new PSX_Url($this->config->getSelf());

		$result = $table->getResultSet($url->getParam('startIndex'), $url->getParam('count'), $url->getParam('sortBy'), $url->getParam('sortOrder'), $url->getParam('filterBy'), $url->getParam('filterOp'), $url->getParam('filterValue'), $url->getParam('updatedSince'), PSX_SQL::FETCH_OBJECT);


		$paging = new PSX_Html_Paging($url, $result);

		$this->template->assign('pagingComments', $paging, 0);


		return $result;
	}
}

