<?php

// shows the user activity for the last x hours
$hours = 12;


$now  = new DateTime('NOW', $this->vars['core.default_timezone']);
$past = new DateTime('NOW', $this->vars['core.default_timezone']);
$past->sub(new DateInterval('PT' . $hours . 'H'));

$act = array();


$result = Amun_Sql_Table_Registry::get('User_Account')
	->select(array('lastSeen'))
	->where('lastSeen', '>=', $past->format(PSX_Time::SQL))
	->orderBy('lastSeen', PSX_Sql::SORT_ASC)
	->getAll()

foreach($result as $row)
{
	$date     = new DateTime($row['accountLastSeen'], $this->vars['core.default_timezone']);
	$interval = $date->diff($now);
	$key      = $interval->format('%h');

	if(!isset($act[$key]))
	{
		$act[$key] = 1;
	}
	else
	{
		$act[$key]++;
	}
}


$now    = time();
$past   = $date->getTimestamp();
$hour   = 3600;

$chd    = array();
$labels = array();
$max    = 0;
$days   = 0;

for($i = $hours - 1; $i >= 0; $i--)
{
	if(isset($act[$i]))
	{
		if($act[$i] > $max)
		{
			$max = $act[$i];
		}

		$chd[$i] = $act[$i];
	}
	else
	{
		$chd[$i] = 0;
	}

	$labels[] = date('H', time() - ($i * 3600));

	$days++;
}


$params = array(

	'cht'  => 'ls',
	'chd'  => 't:' . implode(',', $chd),
	'chs'  => '240x100',
	'chco' => '0077CC',
	'chds' => '0,' . $max,

	'chxt' => 'x',
	'chxl' => '0:|' . implode('|', $labels),
	'chxr' => '0,1,' . $days . ',1',
);


$param = '';

foreach($params as $k => $v)
{
	$param.= $k . '=' . $v . '&';
}

$param = substr($param, 0, -1);

echo '<div style="text-align:center;"><img src="http://chart.apis.google.com/chart?' . $param . '" alt="chart" /></div>';


