

<?php if(count($options) > 0): ?>

<div class="amun_html_options">

	<ul>
		<?php foreach($options as $option): ?>
		<li><a href="<?php echo $option['href']; ?>"><?php echo $option['name']; ?></a></li>
		<?php endforeach; ?>
	</ul>

</div>

<?php endif; ?>


<div class="amun_service_forum">

	<div class="amun_service_forum_entry">
		<h2>
			<a href="<?php echo $recordForum->getUrl(); ?>"><?php echo $recordForum->title; ?></a>
		</h2>
		<span>
			by
			<a href="<?php echo $recordForum->authorProfileUrl; ?>" rel="author"><?php echo $recordForum->authorName; ?></a>
			on
			<time datetime="<?php echo $recordForum->getDate()->format(DateTime::ATOM); ?>"><?php echo $recordForum->getDate()->format($registry['core.format_datetime']); ?></time>
		</span>
		<div class="amun_service_forum_text"><?php echo $recordForum->text; ?></div>
	</div>

</div>


<?php if($resultComments->totalResults > 0): ?>

	<div class="amun_service_comment">

		<?php foreach($resultComments->entry as $record): ?>
		<hr />
		<div class="amun_service_comment_entry" id="comment-<?php echo $record->id; ?>">
			<div class="amun_service_comment_avatar">
				<img src="<?php echo $record->authorThumbnailUrl; ?>" alt="avatar" />
			</div>
			<div class="amun_service_comment_content">
				<span>
					by
					<a href="<?php echo $record->authorProfileUrl; ?>" rel="author"><?php echo $record->authorName; ?></a>
					on
					<time datetime="<?php echo $record->getDate()->format(DateTime::ATOM); ?>"><?php echo $record->getDate()->format($registry['core.format_datetime']); ?></time>
				</span>
				<div class="amun_service_comment_text"><?php echo $record->text; ?></div>
			</div>
		</div>
		<?php endforeach; ?>

	</div>

	<?php if($pagingComments['pages'] > 1): ?>

	<div class="psx_html_paging">

		<ul>
			<li><a href="<?php echo $pagingComments['first']; ?>">First</a></li>
			<li><a href="<?php echo $pagingComments['prev']; ?>">Previous</a></li>
			<li><?php echo $pagingComments['page']; ?> of <?php echo $pagingComments['pages']; ?></li>
			<li><a href="<?php echo $pagingComments['next']; ?>">Next</a></li>
			<li><a href="<?php echo $pagingComments['last']; ?>">Last</a></li>
		</ul>

	</div>

	<?php endif; ?>

<?php endif; ?>


<?php if($user->hasRight('service_forum_comment_add')): ?>

	<hr />

	<div id="response"></div>

	<div id="form"></div>

	<script type="text/javascript">
	var form = new amun.form("form", "<?php echo $url; ?>");

	form.on_error(function(msg){

		$('#response').html(msg);

	});

	form.on_load(function(id){

		var client = new amun.client(id);

		client.before_submit(function(){

			$('#' + id + ' input[type=submit]').attr('disabled', 'disabled');

		});

		client.after_submit(function(){

			$('#' + id + ' input[type=submit]').removeAttr('disabled');

		});

		client.on_success(function(msg){

			window.location.href = "<?php echo $config->getSelf(); ?>";

		});

		client.on_error(function(msg){

			$('#response').html(msg);

		});

	});
	</script>

<?php else: ?>

	<?php if($user->isAnonymous()): ?>

		<hr />

		<p>You must be logged in to post a comment.</p>

	<?php endif; ?>

<?php endif; ?>


