<?php
/*
 *  $Id: signon.php 442 2011-12-04 19:06:59Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * signon
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   module
 * @package    api
 * @subpackage service_my
 * @version    $Revision: 442 $
 */
class signon extends Amun_OpenId_ProviderAbstract
{
	public function onLoad()
	{
		try
		{
			$this->handle();
		}
		catch(Exception $e)
		{
			echo $e->getMessage() . "\n" . $e->getTraceAsString();
			exit;
		}
	}

	public function doLogin()
	{
		$loginUrl = $this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'my.htm/login';

		header('Location: ' . $loginUrl . '?redirect=' . urlencode($this->config->getSelf()));
		exit;
	}

	public function isAuthenticated()
	{
		return $this->session->has('amun_id') && !$this->user->isAnonymous();
	}

	public function onCheckidSetup(PSX_OpenId_Provider_Data_SetupRequest $request)
	{
		// count connect requests
		/*
		$maxCount = 5;
		$con      = new PSX_Sql_Condition(array('userId', '=', $this->user->id), array('status', '=', Amun_System_Api::TEMPORARY));
		$count    = $this->sql->count($this->registry['table.user_account_connect'], $con);

		if($count > $maxCount)
		{
			$conDelete = new PSX_Sql_Condition();
			$result    = $this->sql->select($this->registry['table.user_account_connect'], array('id', 'expire', 'date'), $con, PSX_Sql::SELECT_ALL);

			foreach($result as $row)
			{
				$now  = new DateTime('NOW', $this->registry['core.default_timezone']);
				$date = new DateTime($row['date'], $this->registry['core.default_timezone']);
				$date->add(new DateInterval($row['expire']));

				if($now > $date)
				{
					$conDelete->add('id', '=', $row['id'], 'OR');
				}
			}

			if($conDelete->hasCondition())
			{
				$this->sql->delete($this->registry['table.user_account_connect'], $conDelete);
			}

			throw new Amun_Exception('You can have max ' . $maxCount . ' temporary account connect requests. Each request expires after 30 hour');
		}
		*/


		// sreg extension
		$sreg     = null;
		$params   = $request->getExtension(PSX_OpenId_Extension_Sreg::NS);
		$required = isset($params['required']) ? explode(',', $params['required']) : array();
		$optional = isset($params['optional']) ? explode(',', $params['optional']) : array();
		$fields   = array_merge($required, $optional);

		if(!empty($fields))
		{
			$sreg = PSX_OpenId_Extension_Sreg::validateFields($fields);
		}


		// oauth extension
		$oauth    = null;
		$params   = $request->getExtension(PSX_OpenId_Extension_Oauth::NS);
		$consumer = isset($params['consumer']) ? $params['consumer'] : null;

		if(!empty($consumer))
		{
			$oauth = array('consumer' => $consumer);
		}


		// insert connect
		$_SESSION['openid_connect'] = array(

			'claimedId' => $request->getClaimedId(),
			'identity'  => $request->getIdentity(),
			'returnTo'  => (string) $request->getReturnTo(),
			'sreg'      => $sreg,
			'oauth'     => $oauth,

		);


		// redirect
		header('Location: ' . $this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'my.htm/connect');
		exit;
	}

	public function onCheckAuthentication($assocHandle)
	{
		$sql = <<<SQL
SELECT

	`connect`.`sig`,
	`connect`.`secret`

	FROM {$this->registry['table.system_connect']} `connect`

			WHERE `connect`.`assocHandle` = ?

			AND `connect`.`status` = ?
SQL;

		$row = $this->sql->getRow($sql, array($assocHandle, Amun_System_Api::APPROVED));

		if(!empty($row))
		{
			// set status to access
			/*
			if this is set the checkAuthentication mode can be called only once
			the next request for this assocHandle would throw an error
			$con = new PSX_Sql_Condition(array('assocHandle', '=', $assocHandle));

			$this->sql->update($this->registry['table.system_connect'], array(

				'status' => Amun_System_Connect::ACCESS,
				'expire' => 'P1M',

			), $con);
			*/


			// return autnetication
			$auth = new PSX_OpenId_Provider_Data_Authentication($row['secret'], $row['sig']);

			return $auth;
		}
	}
}

