<?php
/*
 *  $Id: index.php 442 2011-12-04 19:06:59Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * index
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   module
 * @package    my
 * @version    $Revision: 442 $
 */
class index extends Amun_Service_My_MyAbstract
{
	public function onLoad()
	{
		parent::onLoad();


		// get user details
		$account = $this->getAccount();

		$this->template->assign('account', $account);


		// get acctivites
		$activities = $this->getActivities();

		$this->template->assign('activities', $activities);


		// template
		$this->htmlCss->add('my');
		$this->htmlContent->add(Amun_Html_Content::META, PSX_Data_Writer_Atom::link($this->page->title, $this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'api/service/my/activity/' . $this->user->name . '?format=atom'));

		$this->template->set('application/' . $this->page->application . '/' . __CLASS__ . '.tpl');
	}

	private function getAccount()
	{
		return Amun_Sql_Table_Registry::get('User_Account')
			->select(array('id', 'status', 'name', 'gender', 'timezone', 'updated', 'date', 'thumbnailUrl'))
			->join(PSX_Sql_Join::INNER, Amun_Sql_Table_Registry::get('User_Group')
				->select(array('title'), 'group')
			)
			->join(PSX_Sql_Join::INNER, Amun_Sql_Table_Registry::get('System_Country')
				->select(array('title'), 'country')
			)
			->where('id', '=', $this->user->id)
			->getRow(PSX_Sql::FETCH_OBJECT);
	}

	private function getActivities()
	{
		$sql = <<<SQL
SELECT

	`activity`.`id`          AS `id`,
	`activity`.`verb`        AS `verb`,
	`activity`.`title`       AS `title`,
	`activity`.`summary`     AS `summary`,
	`activity`.`date`        AS `date`,
	`account`.`name`         AS `authorName`,
	`account`.`profileUrl`   AS `authorProfileUrl`,
	`account`.`thumbnailUrl` AS `authorThumbnailUrl`

	FROM `{$this->registry['table.user_activity']}` AS `activity`

	INNER JOIN `{$this->registry['table.user_account']}` AS `account`

		ON `activity`.`userId` = `account`.`id`

		WHERE `activity`.`userId` IN (SELECT `friendId` FROM `{$this->registry['table.user_friend']}` WHERE `userId` = 3)

			ORDER BY `activity`.`date` DESC

			LIMIT 0, 16
SQL;

		$result = $this->sql->getAll($sql, array(), PSX_Sql::FETCH_OBJECT, 'Amun_User_Activity', array(Amun_Sql_Table_Registry::get('User_Activity')));

		return $result;
	}
}
