<?php
/*
 *  $Id: activate.php 442 2011-12-04 19:06:59Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * activate
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   module
 * @package    my
 * @version    $Revision: 442 $
 */
class activate extends Amun_ApplicationAbstract
{
	public function onLoad()
	{
		// add path
		$this->path->add('Register', $this->page->url . '/register');
		$this->path->add('Activate', $this->page->url . '/register/activate');


		// template
		$this->htmlCss->add('my');

		$this->template->set('application/' . $this->page->application . '/register/' . __CLASS__ . '.tpl');
	}

	public function onGet()
	{
		try
		{
			$token = $this->get->token('string', array(new PSX_Filter_Length(40, 40), new PSX_Filter_Xdigit()));

			if($token !== false)
			{
				$account = Amun_Sql_Table_Registry::get('User_Account')
					->select()
					->setColumns(array('id', 'ip', 'date'))
					->addCondition('token', '=', $token)
					->addCondition('status', '=', Amun_User_Account::NOT_ACTIVATED)
					->getRow(PSX_Sql::FETCH_OBJECT);

				if($account instanceof Amun_User_Account)
				{
					try
					{
						$expire = 'PT24H'; // expire after 24 hours
						$now    = new DateTime('NOW', $this->registry['core.default_timezone']);

						if($now > $account->getDate()->add(new DateInterval($expire)))
						{
							throw new Amun_Exception('Activation is expired');
						}

						if($_SERVER['REMOTE_ADDR'] == $account->ip)
						{
							$account->setStatus(Amun_User_Account::NORMAL);

							$handler = new Amun_User_Account_Handler($this->config, $this->sql, $this->registry, $this->user);
							$handler->update($account);


							$this->template->assign('success', true);
						}
						else
						{
							throw new Amun_Exception('Registration was requested from another IP');
						}
					}
					catch(Exception $e)
					{
						$con = new PSX_Sql_Condition();
						$con->add('id', '=', $account->id);
						$con->add('status', '=', Amun_User_Account::NOT_ACTIVATED);

						$this->sql->delete($this->registry['table.user_account'], $con);

						throw $e;
					}
				}
				else
				{
					throw new Amun_Exception('Invalid token');
				}
			}
			else
			{
				throw new Amun_Exception('Token not set');
			}
		}
		catch(Exception $e)
		{
			$this->template->assign('error', $e->getMessage());
		}
	}
}
