<?php
/*
 *  $Id: People.php 442 2011-12-04 19:06:59Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Amun_Service_My_People
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   Amun
 * @package    Amun_Service_My
 * @version    $Revision: 442 $
 */
class Amun_Service_My_People extends Amun_User_Friend
{
	public function getName()
	{
		return 'person';
	}

	public function getFields()
	{
		return array(

			'id'           => $this->friendId,
			'displayName'  => $this->friendName,
			'profileUrl'   => $this->friendProfileUrl,
			'thumbnailUrl' => $this->friendThumbnailUrl,
			'updated'      => $this->friendUpdated,
			'published'    => $this->date,
			'connected'    => $this->status == self::NORMAL,

		);
	}

	public function export(PSX_Data_WriterResult $result)
	{
		switch($result->getType())
		{
			case PSX_Data_WriterInterface::JSON:
			case PSX_Data_WriterInterface::XML:

				return $this->getFields();

				break;

			case PSX_Data_WriterInterface::ATOM:

				$entry = $result->getWriter()->createEntry($this->friendName, $this->friendGlobalId, $this->getDate());

				$entry->addAuthor($this->authorName, $this->authorProfileUrl);

				$entry->addLink($this->friendProfileUrl, 'alternate', 'text/html');

				$entry->setContent($this, 'application/xml');

				return $entry;

				break;

			default:

				throw new PSX_Data_Exception('Writer is not supported');

				break;
		}
	}
}
