/*
 *  $Id: default.js 356 2011-10-10 21:35:26Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

(function(win){

	var my = {};

	my.login_detection = function(){

		this.is_uri = function(value){

			return (value.indexOf('@') == -1 && value.indexOf('.') != -1) || (value.substring(0, 7) == 'http://' || value.substring(0, 8) == 'https://');

		}

		this.is_provider = function(value){

			for(var i = 0; i < amun_provider.length; i++)
			{
				if(((pos = value.indexOf('@')) != -1) && value.indexOf('.') != -1 && value.substr(pos + 1) == amun_provider[i])
				{
					return true;
				}
			}

			return false;

		}

		this.is_email = function(value){

			return value.indexOf('@') != -1 && value.indexOf('.') != -1;

		}

		this.is_valid_input = function(value){

			if(value.length < 3 || value.length > 256)
			{
				return false;
			}

			for(var i = 0; i < value.length; i++)
			{
				if(value.charCodeAt(i) == 0x20)
				{
					return false;
				}
			}

			return true;

		}

		this.set_image = function(bg_url){

			if(bg_url != false)
			{
				$('#recognition_icon').html('<img src="' + bg_url + '" />');
			}
			else
			{
				$('#recognition_icon').html('&nbsp;');
			}

		}

		this.disable_fields = function(bg_url){

			$('#pw').val('');
			$('#pw').attr('disabled', 'disabled');
			$('#pw').css('background-color', '#d4d0c8');

			$('#login').focus();

			this.set_image(bg_url);

		}

		this.enable_fields = function(bg_url){

			$('#pw').val('');
			$('#pw').removeAttr('disabled');
			$('#pw').css('background-color', '#ffffff');

			$('#pw').focus();

			this.set_image(bg_url);

		}

		this.reset = function(){

			this.enable_fields(false);

			$('#identity').val('');
			$('#identity').focus();

		}

		var value = $('#identity').val();

		if(!this.is_valid_input(value))
		{
			this.enable_fields(psx_base + '/img/icons/login/exclamation.png');
		}
		else if(this.is_uri(value))
		{
			this.disable_fields(psx_base + '/img/icons/login/openid.png');
		}
		else if(this.is_provider(value))
		{
			this.disable_fields(psx_base + '/img/icons/login/openid.png');
		}
		else if(this.is_email(value))
		{
			this.enable_fields(psx_base + '/img/icons/login/email.png');
		}
		else
		{
			this.enable_fields(false);
		}

	}

	win.my = my;

})(window);


function load_settings_form(id, url)
{
	var form = new amun.form(id, url);

	form.on_error(function(msg){

		$('#response').html(msg);

	});

	form.on_load(function(id){

		var client = new amun.client(id);

		client.before_submit(function(){

			$('#' + id + ' input[type=submit]').attr('disabled', 'disabled');

		});

		client.after_submit(function(){

			$('#' + id + ' input[type=submit]').removeAttr('disabled');

		});

		client.on_success(function(msg){

			$('#response').html(msg);

			window.setTimeout('location.reload()', 500);

		});

		client.on_error(function(msg){

			$('#response').html(msg);

		});

	});
}


