<?php
/*
 *  $Id: index.php 442 2011-12-04 19:06:59Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * index
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   module
 * @package    plugin
 * @subpackage news
 * @version    $Revision: 442 $
 */
class index extends Amun_ApplicationAbstract
{
	public function onLoad()
	{
		if($this->user->hasRight('service_news_view'))
		{
			// load news
			$resultNews = $this->getNews();

			$this->template->assign('resultNews', $resultNews);


			// options
			$options = new Amun_Option(__CLASS__, $this->registry, $this->user, $this->page);
			$options->add('service_news_add', 'Add', $this->page->url . '/add');
			$options->load(array($this->page));

			$this->template->assign('options', $options);


			// template
			$this->htmlCss->add('news');
			$this->htmlContent->add(Amun_Html_Content::META, PSX_Data_Writer_Atom::link($this->page->title, $this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'api/service/news?format=atom&filterBy=pageId&filterOp=equals&filterValue=' . $this->page->id));

			$this->template->set('application/' . $this->page->application . '/' . __CLASS__ . '.tpl');
		}
		else
		{
			throw new Amun_Exception('Access not allowed');
		}
	}

	private function getNews()
	{
		$select = Amun_Sql_Table_Registry::get('Service_News')
			->select(array('id', 'title', 'url', 'text', 'date'))
			->join(PSX_Sql_Join::INNER, Amun_Sql_Table_Registry::get('User_Account')
				->select(array('name', 'profileUrl'), 'author')
			)
			->join(PSX_Sql_Join::INNER, Amun_Sql_Table_Registry::get('Content_Page')
				->select(array('path'), 'page')
			)
			->where('pageId', '=', $this->page->id);


		$fragments = $this->getUriFragments();

		if(isset($fragments[0]) && $fragments[0] == 'archive')
		{
			$rawDate = isset($fragments[1]) && strlen($fragments[1]) == 6 ? $fragments[1] : date('Ym');

			$year  = intval(substr($rawDate, 0, 4));
			$month = intval(substr($rawDate, 4));

			// i think this software will not be used after the year 3000
			// if so please travel back in time and slap me in the face
			// ... nothing happens ;D
			if(($year > 2010 && $year < 3000) && ($month > 0 && $month < 13))
			{
				$date = new DateTime($year . '-' . ($month < 10 ? '0' : '') . $month . '-01', $this->registry['core.default_timezone']);

				$select->addCondition('date', '>=', $date->format(PSX_Time::SQL));
				$select->addCondition('date', '<', $date->add(new DateInterval('P1M'))->format(PSX_Time::SQL));
			}
		}


		$url = new PSX_Url($this->config->getSelf());

		$result = $select->getResultSet($url->getParam('startIndex'), $url->getParam('count'), $url->getParam('sortBy'), $url->getParam('sortOrder'), $url->getParam('filterBy'), $url->getParam('filterOp'), $url->getParam('filterValue'), $url->getParam('updatedSince'), PSX_SQL::FETCH_OBJECT);


		$paging = new PSX_Html_Paging($url, $result);

		$this->template->assign('pagingNews', $paging, 0);


		return $result;
	}
}

