<?php
/*
 *  $Id: edit.php 442 2011-12-04 19:06:59Z k42b3.x@googlemail.com $
 *
 * amun
 * A social content managment system based on the psx framework. For
 * the current version and informations visit <http://amun.phpsx.org>
 *
 * Copyright (c) 2010 Christoph Kappestein <k42b3.x@gmail.com>
 *
 * This file is part of amun. amun is free software: you can
 * redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or any later version.
 *
 * amun is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with amun. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * edit
 *
 * @author     Christoph Kappestein <k42b3.x@gmail.com>
 * @license    http://www.gnu.org/licenses/gpl.html GPLv3
 * @link       http://amun.phpsx.org
 * @category   module
 * @package    service
 * @subpackage page
 * @version    $Revision: 442 $
 */
class edit extends Amun_ApplicationAbstract
{
	public function onLoad()
	{
		if($this->user->hasRight('service_page_edit'))
		{
			// form url
			$id = $this->get->id('integer');

			if($id > 0)
			{
				$url = $this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'api/service/page/form?format=json&method=update&id=' . $id;
			}
			else
			{
				$url = $this->config['psx_url'] . '/' . $this->config['psx_dispatch'] . 'api/service/page/form?format=json&method=create&pageId=' . $this->page->id;
			}


			// add path
			$this->path->add('Edit', $this->page->url . '/edit?id=' . $id);


			// template
			$this->htmlJs->add('amun');
			$this->htmlJs->add('ace');
			$this->htmlJs->add('page');


			echo <<<HTML
<div id="response"></div>

<div id="form"></div>

<script type="text/javascript">
loadForm("form", "{$url}")
</script>
HTML;
		}
		else
		{
			throw new Amun_Exception('Access not allowed');
		}
	}
}

