

<?php if(count($options) > 0): ?>

<div class="amun_html_options">

	<ul>
		<?php foreach($options as $option): ?>
		<li><a href="<?php echo $option['href']; ?>"><?php echo $option['name']; ?></a></li>
		<?php endforeach; ?>
	</ul>

</div>

<?php endif; ?>

<div class="amun_service_profile vcard">

	<div class="amun_service_profile_avatar"><img src="<?php echo $account->thumbnailUrl; ?>" class="photo avatar" alt="<?php echo $account->name; ?>" /></div>

	<h2><a href="<?php echo $account->profileUrl; ?>" rel="me" class="nickname url uid"><?php echo $account->name; ?></a></h2>

	<div class="span-5">

		<dl>
			<dt>Karma</dt>
			<dd><?php echo $account->getKarma(); ?></dd>

			<dt>Registered on</dt>
			<dd><?php echo $account->getDate()->format($registry['core.format_date']); ?></dd>

			<?php if($account->gender != 'undisclosed'): ?>
			<dt>Gender</dt>
			<dd><?php echo ucfirst($account->gender); ?></dd>
			<?php endif; ?>

			<?php if($account->countryTitle != 'Undisclosed'): ?>
			<dt>Country</dt>
			<dd><?php echo $account->countryTitle; ?></dd>
			<?php endif; ?>

			<?php if(!empty($account->timezone)): ?>
			<dt>Timezone</dt>
			<dd><?php echo $account->timezone; ?></dd>
			<?php endif; ?>
		</dl>

	</div>

	<div class="span-18 last">

		<div class="amun_service_profile_activity">

			<?php foreach($activities as $activity): ?>
			<div class="amun_service_profile_activity_entry" id="activity-<?php echo $activity->id; ?>">
				<div class="amun_service_profile_activity_avatar">
					<img src="<?php echo $activity->authorThumbnailUrl; ?>" alt="avatar" />
				</div>
				<div class="amun_service_profile_activity_content">
					<h3><a href="<?php echo $activity->authorProfileUrl; ?>"><?php echo $activity->authorName; ?></a></h3>
					<div class="amun_service_profile_activity_title"><?php echo $activity->title; ?></div>
					<?php if(!empty($activity->summary)): ?>
						<div class="amun_service_profile_activity_summary"><?php echo $activity->summary; ?></div>
					<?php endif; ?>
					<span>
						on
						<time datetime="<?php echo $activity->getDate()->format(DateTime::ATOM); ?>"><?php echo $activity->getDate()->format($registry['core.format_datetime']); ?></time>
					</span>
				</div>
			</div>
			<hr />
			<?php endforeach; ?>

		</div>

		<?php if($pagingActivities['pages'] > 1): ?>

		<div class="psx_html_paging">

			<ul>
				<li><a href="<?php echo $pagingActivities['first']; ?>">First</a></li>
				<li><a href="<?php echo $pagingActivities['prev']; ?>">Previous</a></li>
				<li><?php echo $pagingActivities['page']; ?> of <?php echo $pagingActivities['pages']; ?></li>
				<li><a href="<?php echo $pagingActivities['next']; ?>">Next</a></li>
				<li><a href="<?php echo $pagingActivities['last']; ?>">Last</a></li>
			</ul>

		</div>

		<?php endif; ?>

		<br />

		<small>Last updated on <?php echo $account->getUpdated()->format($registry['core.format_date']); ?></small>

	</div>

</div>

<script type="text/javascript">

function friendship_request(user_id, friend_id, el)
{
	var client = new amun.client();
	var url = '<?php echo $target; ?>';

	client.on_success(function(){

		alert('You have successful send an friendship request');

	});

	client.on_error(function(msg){

		alert(msg);

	});

	client.request(url, 'POST', {userId: user_id, friendId: friend_id});
}

</script>

